<template>
  <transition name="bounce">
    <div
      v-if="toast && visible"
      class="absolute flex max-w-xs w-full mt-4 mr-4 top-0 right-0 bg-green-200 rounded shadow p-4"
    >
      <div class="mr-2">
        <svg
          xmlns="http://www.w3.org/2000/svg"
          class="h-6 w-6 text-green-600"
          fill="none"
          viewBox="0 0 24 24"
          stroke="currentColor"
        >
          <path
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            d="M9 12l2 2 4-4m6 2a9 9 0 11-18 0 9 9 0 0118 0z"
          />
        </svg>
      </div>
      <div class="flex-1 text-gray-800">{{toast.message}}</div>
      <div class="ml-2">
        <button class="align-top text-gray-500 hover:text-gray-700 focus:text-indigo-600">
          <svg
            xmlns="http://www.w3.org/2000/svg"
            class="h-6 w-6"
            fill="none"
            viewBox="0 0 24 24"
            stroke="currentColor"
          >
            <path
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke-width="2"
              d="M6 18L18 6M6 6l12 12"
            />
          </svg>
        </button>
      </div>
    </div>
  </transition>
</template>

<script>
export default {
  props: {
    toast: Object,
  },
  data() {
    return {
      visible: false,
      timeout: null,
    };
  },
  watch: {
    toast: {
      deep: true,
      handler() {
        this.visible = true;

        if (this.timeout) {
          clearTimeout(this.timeout);
        }
        this.timeout = setTimeout(() => (this.visible = false), 1000);
      },
    },
  },
};
</script>

<style>
.bounce-enter-active {
  animation: bounce-in 0.5s;
}
.bounce-leave-active {
  animation: bounce-in 0.5s reverse;
}
@keyframes bounce-in {
  0% {
    transform: scale(0);
  }
  50% {
    transform: scale(1.5);
  }
  100% {
    transform: scale(1);
  }
}
</style>
